package Source::Repository::Mass::ALTLinuxBackport;

use strict;
use warnings;
#use Carp;
use RPM::Vercmp;

use Source::Repository::Mass;
use RPM::Source::Convert::ALTLinuxBackport 0.004;
use Source::Repository::Matcher;
# use of DistroMap Matcher looks excess here due to suppress_rename=1
# no Source::Repository::Matcher::DistroMap;
use Source::Shared::Resource::DistroMap;
use Source::Repository::Mass::RPMEpoch;

use Source::Repository::Mass::Transform;
# pure mixer class
our @ISA = qw/Source::Shared::CLI/;
push @Source::Repository::Mass::EXT_LONGOPT_CLASSES, __PACKAGE__;

our $VERSION=0.005;
our $verbose=0;

$Source::Repository::Mass::Transform::suppress_rename=1;
$Source::Repository::Mass::strategy = 'newer';
$Source::Repository::Mass::epoch_comparator=\&Source::Package::Comparators::rpm40_epoch_comparator;
#$Source::Repository::Mass::version_comparator=\&Source::Package::Comparators::pure_rpm_version_comparator;
$Source::Repository::Mass::release_comparator=\&altbackport_release_comparator;

$DistroMap::default_originrepo='altlinux';
$DistroMap::default_originbranch='sisyphus';
$DistroMap::default_destrepo='altlinux';
$DistroMap::default_destbranch='p10';

{
    no warnings 'once';
    ### MIX-IN ###
    # This method is redundant unless PassThrough is used;
    *before_process_options=*RPM::Source::Convert::ALTLinuxBackport::before_process_options;
}

# ===== STATIC ===

sub altbackport_release_comparator {
    my ($origin,$dest) =@_;
    my $originrelease=$origin->release;
    my $destrelease=$dest->release;
    my $autoportsrelease=&RPM::Source::Convert::ALTLinuxBackport::_nextrel_altbackport_raw($originrelease, $RPM::Source::Convert::ALTLinuxBackport::backport_suffix);
    return 0 if $destrelease eq $autoportsrelease or $destrelease eq $originrelease;
    # Binary "cmp" returns -1, 0, or 1 depending on whether the left argument
    # is stringwise less than, equal to, or greater than the right argument.
    my $cmp=RPM::Vercmp::evrcmp($originrelease,$destrelease);
    print STDERR "$originrelease rpmcmp $destrelease = $cmp\n" if $verbose>1;
    return $cmp if $cmp <= 0;
    $cmp=RPM::Vercmp::evrcmp($autoportsrelease,$destrelease);
    print STDERR "$autoportsrelease rpmcmp $destrelease = $cmp\n" if $verbose>1;
    return $cmp;
}

1;
