package Source::Repository::Mass::NameFilter;

use strict;
use warnings;

our $VERSION=0.002;

use Source::Shared::CLI;
our @ISA=qw/Source::Shared::CLI/;

our @NAME_SKIP_CLASSES;
BEGIN {
 @NAME_SKIP_CLASSES=qw//;
}

sub cli_container_ref {
    my ($self)=@_;
    return \@NAME_SKIP_CLASSES;
}

sub namefilter {
    my $class=shift;
    foreach my $filter (@NAME_SKIP_CLASSES) {
	return 1 if $filter->namefilter(@_);
    }
    return;
}

sub postnamefilter {
    my $class=shift;
    map {$_->postnamefilter(@_)} @NAME_SKIP_CLASSES;
}

sub debug {
    print STDERR "DEBUG: NameFilter: filters=",join(',',@NAME_SKIP_CLASSES),"\n";
}

1;
