package Source::Repository::Matcher;

use Carp;
use strict;
use warnings;
use Source::Shared::CLI;
our @ISA=qw/Source::Shared::CLI/;

our $VERSION=0.005;
our $verbose=0;

our @NAME_MATCH_CLASSES;
BEGIN {
 @NAME_MATCH_CLASSES=qw//;
}

sub cli_container_ref {
    return \@NAME_MATCH_CLASSES;
}

sub origin2dest {
   my ($self,$name,$resourceobj)=@_;
   foreach my $mapper (@Source::Repository::Matcher::NAME_MATCH_CLASSES) {
       my $newname=$mapper->origin2dest($name,$resourceobj);
       if (defined $newname) {
	   return $newname;
       }
   }
   return $name;
}

sub dest2origin {
   my ($self,$name,$resourceobj)=@_;
   foreach my $mapper (@Source::Repository::Matcher::NAME_MATCH_CLASSES) {
       my $newname=$mapper->dest2origin($name,$resourceobj);
       if (defined $newname) {
	   return $newname;
       }
   }
   return $name;
}

1;
