package Source::Repository::Matcher::DistroMap;

use strict;
use warnings;
use Source::Repository::Matcher;
use Source::Shared::Resource::DistroMap;

our @ISA = qw(Source::Repository::Matcher);
push @Source::Repository::Matcher::NAME_MATCH_CLASSES, __PACKAGE__;

our $verbose=0;

sub origin2dest { 
    my ($self,$name,$resourceobj)=@_;
    my @resolve=$resourceobj->get_distromap->multimap_source_origin2dest($name);
    print STDERR "Matcher::DistroMap: origin2dest($name)=",join(',',@resolve),"\n" if $verbose;
    return wantarray ? @resolve: $resolve[0];
}

sub dest2origin {
    my ($self,$name,$resourceobj)=@_;
    my @resolve=$resourceobj->get_distromap->multimap_source_dest2origin($name);
    print STDERR "Matcher::DistroMap: dest2origin($name)=",join(',',@resolve),"\n" if $verbose;
    return wantarray ? @resolve: $resolve[0];
}

1;
