package Source::Repository::Matcher::PyPI2ALT;
use strict;
use warnings;
use Source::Repository::Matcher;
use Source::Shared::Resource::DistroMap;

our @ISA = qw(Source::Repository::Matcher);
push @Source::Repository::Matcher::NAME_MATCH_CLASSES, __PACKAGE__;

$DistroMap::default_originrepo='pypi';
$DistroMap::default_destrepo='altlinux';

our $verbose;

sub origin2dest { 
    my ($self,$name,$resourceobj)=@_;
    my @resolve=$resourceobj->get_distromap->multimap_source_origin2dest($name);
    unless (scalar @resolve) {
	push @resolve, 'python-module-'.$name;
	#push @resolve, 'python3-module-'.$name;
	print STDERR "Matcher::PyPI2ALT: no distromap for $name, added prefix\n" if $verbose;
    }
    print STDERR "Matcher::DistroMap: origin2dest($name)=",join(',',@resolve),"\n" if $verbose;
    return wantarray ? @resolve: $resolve[0];
}

sub dest2origin {
    my ($self,$name,$resourceobj)=@_;
    my @resolve=$resourceobj->get_distromap->multimap_source_dest2origin($name);
    unless (scalar @resolve) {
	my $origin=$name;
	$origin=~s,^python\d?-module-,,;
	push @resolve, $origin;
	print STDERR "Matcher::PyPI2ALT: no distromap for $name, removed prefix to $origin\n" if $verbose;
    }
    print STDERR "Matcher::DistroMap: dest2origin($name)=",join(',',@resolve),"\n" if $verbose;
    return wantarray ? @resolve: $resolve[0];
}

1;
